#include "junta_puchos.h"

junta_puchos *make_junta_puchos(char *name, colillas_t *colillas){
        junta_puchos *jp;
        jp = (junta_puchos *)malloc(sizeof(junta_puchos));
        jp->name = name;
        jp->colillas = colillas;
        pthread_create(&jp->pid, NULL, (void *)get_colillas, jp);
        return jp;
}

fumador *make_fumador(char *name, colillas_t *colillas){
        fumador *fum;
        fum = (fumador *)malloc(sizeof(fumador));
        fum->name = name;
        fum->colillas = colillas;
        pthread_create(&fum->pid, NULL, (void *)fumar, fum);
        return fum;
}

void echar(junta_puchos *jp) {
        pthread_join(jp->pid, NULL);
        free(jp);
}

void get_colillas(junta_puchos * jp){
        printf("%s en accion\n", jp->name);
	while(1){
		pthread_mutex_lock(&jp->colillas->s_colillas);
       		while(jp->colillas->ncolillas <  NCOLILLAS){
			printf("%s buscando una colilla pal pucho, le faltan %d\n", jp->name, NCOLILLAS);
			pthread_cond_wait(&jp->colillas->condition, &jp->colillas->s_colillas);
		}
	     	jp->colillas->ncolillas -= NCOLILLAS;
		pthread_cond_signal(&jp->colillas->condition);
		pthread_mutex_unlock(&jp->colillas->s_colillas);

		make_pucho(jp);

		pthread_mutex_lock(&jp->colillas->s_colillas);
		jp->colillas->ncolillas++;
		printf("Quedan %d colillas\n", jp->colillas->ncolillas);
		pthread_cond_signal(&jp->colillas->condition);
		pthread_mutex_unlock(&jp->colillas->s_colillas);
        }
}

void make_pucho(junta_puchos *jp){
        printf("%s preparando pucho\n", jp->name);
        sleep(1);
        printf("%s fumando\n", jp->name);
        sleep(1);
        printf("Se le acabo el pucho a %s...\n", jp->name);
}

void fumar(fumador *fum){

	while(1){
		printf("%s está fumando un fino cigarrillo\n", fum->name);
        	sleep(1);
        	
		pthread_mutex_lock(&fum->colillas->s_colillas);
        	
		fum->colillas->ncolillas++;
		printf("%s ha terminado su cigarro y ha botado una colilla\n", fum->name);
        	printf("Quedan %d colillas\n", fum->colillas->ncolillas);
        	
		pthread_cond_signal(&fum->colillas->condition);
        	pthread_mutex_unlock(&fum->colillas->s_colillas);

                sleep(1);
	}

}

colillas_t *make_colillas(int ncolillas){
	colillas_t *colillas = (colillas_t *)malloc(sizeof(colillas_t));
	colillas->ncolillas = ncolillas;
	pthread_mutex_init(&colillas->s_colillas, NULL);
        pthread_cond_init(&colillas->condition, NULL);
	return colillas;
}
        
void free_colillas(colillas_t *colillas){
	free(colillas);
}

int main(){
        int i;
        junta_puchos *junta_puchos[NJP];
	fumador *fum;
	colillas_t *colillas;

	colillas = make_colillas(INITIAL_COLILLAS);
        char *nombres[NJP] = {"Don Juan", "El Patraña", "Don Pepe", "El negro Piter", "Don Goyo"};
        printf("Hay %d junta_puchos y %d colillas, empieza la fumaton\n", NJP, INITIAL_COLILLAS);

	
        for(i = 0; i<NJP; i++)
                junta_puchos[i] = make_junta_puchos(nombres[i], colillas);
        fum = make_fumador("Fumador compulsivo", colillas);
        for(i = 0; i < NJP; i++)
                echar(junta_puchos[i]);
	echar(fum);
	free_colillas(colillas);
	return EXIT_SUCCESS;
}

