#include <pthread.h>
#include <semaphore.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#define NCOLILLAS 5
#define NJP 5
#define INITIAL_COLILLAS 8

typedef struct {
        pthread_mutex_t s_colillas;
        pthread_cond_t condition;
        int ncolillas;
} colillas_t;

typedef struct {
	pthread_t pid;
	char *name;
	colillas_t *colillas;
} junta_puchos;

typedef junta_puchos fumador;

junta_puchos *make_junta_puchos(char *, colillas_t *);
void echar(junta_puchos *);
void get_colillas(junta_puchos *);
void make_pucho(junta_puchos *);

fumador *make_fumador(char *, colillas_t *);
void fumar(fumador *);

colillas_t *make_colillas(int);
void free_colillas(colillas_t *);
