#include <stdio.h>
#include <stdlib.h>
#include "./jsocket.h"
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>


#define BUF_SIZE 200
#define MAX_CLIENTS 2
#define PORT 1818

main() {
   int s, s2;
   int cnt, size = BUF_SIZE;
   char buf[BUF_SIZE];
   int ret;
   fd_set mask;
   int client[MAX_CLIENTS];
   char * nick[MAX_CLIENTS];
   int i, j;

   /* para no morirme al morir un cliente */
   signal(SIGPIPE, SIG_IGN);

   /* Arreglo de sockets de los clientes */
   for( i = 0; i < MAX_CLIENTS; i++ ) {
	client[i] = -1;
        nick[i] = NULL;
   }

   s = j_socket();

   if(j_bind(s, PORT) < 0) {
	fprintf(stderr, "bind failed\n");
	exit(1);
   }

   for(;;) {
	FD_ZERO(&mask);
	FD_SET(s, &mask);	/* el socket de accept */
	for(i = 0; i < MAX_CLIENTS; i++) /* cada socket cliente */
	     if( client[i] != -1 )
	          FD_SET(client[i], &mask);

        /* espero que haya actividad en algun socket */
	ret = select( getdtablesize(), &mask, NULL, NULL, NULL);

	if( ret <= 0 ) { perror("select"); exit(-1);}

        /* Atendemos los clientes con datos */
	for(i = 0; i < MAX_CLIENTS; i++) {
	    if(client[i] != -1 && FD_ISSET(client[i], &mask)) {
		if((cnt = read(client[i], buf, size)) > 0){
		    if(nick[i] == NULL){
		       nick[i] = (char *)malloc(cnt);
		       buf[cnt-2] = ':';
                       buf[cnt-1] = '\0';
                       strcpy(nick[i], buf);
		       fprintf(stderr, "cliente con nick %s\n", nick[i]);
	            }
		    else	
		        for(j = 0; j < MAX_CLIENTS; j++)
		            if(client[j] != -1 && j != i){
			       write(client[j], nick[i], strlen(nick[i])); /* El nombre de quien escribio el mensaje */
	    	    	       write(client[j], buf, cnt); /* El mensaje */
			    }
 		}
		else { /* murio un cliente */
		    fprintf(stderr, "cliente %s desconectado\n", nick[i]);
		    close(client[i]);
		    client[i] = -1;
		    free(nick[i]);
		    nick[i] = NULL;
		}
	    }
	}

        /* aceptamos conexion pendiente si hay una */
	if(FD_ISSET(s, &mask)) {
	    for( i = 0; i < MAX_CLIENTS; i++ )
		if(client[i] == -1) break;
	    if(i == MAX_CLIENTS) exit(1); /* No caben mas: me suicido */
	    client[i] = j_accept(s);
            strcpy(buf, "Escriba su nick ");
            write(client[i], buf, strlen("Escriba su nick ") + 1);
	    fprintf(stderr, "cliente conectado\n");
	}
   }
}
